Index: palm/trunk/SOURCE/check_open.f90
===================================================================
--- palm/trunk/SOURCE/check_open.f90	(revision 4901)
+++ palm/trunk/SOURCE/check_open.f90	(revision 1)
@@ -1,71 +1,96 @@
-!> @file check_open.f90
-!--------------------------------------------------------------------------------------------------!
-! This file is part of the PALM model system.
-!
-! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
-! Public License as published by the Free Software Foundation, either version 3 of the License, or
-! (at your option) any later version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
-! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
-! Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with PALM. If not, see
-! <http://www.gnu.org/licenses/>.
-!
-!
-! Copyright 1997-2021 Leibniz Universitaet Hannover
-!--------------------------------------------------------------------------------------------------!
-!
-! Current revisions:
+ SUBROUTINE check_open( file_id )
+
+!------------------------------------------------------------------------------!
+! Actual revisions:
 ! -----------------
-!
+! 
 !
 ! Former revisions:
 ! -----------------
-! $Id$
-! local filename for output of particle time series changed
-!
-! 4652 2020-08-27 08:51:55Z raasch
-! Routine fortran_sleep has been moved to module posix_interface
-! 
-! 4577 2020-06-25 09:53:58Z raasch
-! further re-formatting to follow the PALM coding standard
-!
-! 4546 2020-05-24 12:16:41Z raasch
-! file re-formatted to follow the PALM coding standard
-!
-! 4444 2020-03-05 15:59:50Z raasch
-! bugfix: cpp-directives for serial mode added
-!
-! 4400 2020-02-10 20:32:41Z suehring
-! Remove binary output for virtual measurements
-!
-! 4360 2020-01-07 11:25:50Z suehring
-! Corrected "Former revisions" section
-!
-! 4128 2019-07-30 16:28:58Z gronemeier
-! Bugfix for opening the parameter file (unit 11): return error message if file
-! was not found.
-!
-! 4099 2019-07-15 15:29:37Z suehring
-! Bugfix in opening the parameter file (unit 11) in case of ocean precursor
-! runs.
-!
-! 4069 2019-07-01 14:05:51Z Giersch
-! Masked output running index mid has been introduced as a local variable to
-! avoid runtime error (Loop variable has been modified) in time_integration
-!
-! 3967 2019-05-09 16:04:34Z gronemeier
-! Save binary data of virtual measurements within separate folder
-!
-! 3812 2019-03-25 07:10:12Z gronemeier
-! Open binary surface output data within separate folder
-!
-! 3705 2019-01-29 19:56:39Z suehring
-! Open binary files for virtual measurements
-!
-! 3704 2019-01-29 19:51:41Z suehring
-! Open files for surface data
+! $Log: check_open.f90,v $
+! Revision 1.44  2006/08/22 13:48:34  raasch
+! xz and yz cross sections now up to nzt+1
+!
+! Revision 1.43  2006/08/04 14:05:52  raasch
+! Opening of unit 109 (particle time series)
+!
+! Revision 1.42  2006/03/01 16:39:47  raasch
+! In parallel mode, all PEs are opening the same copy of file PARIN
+!
+! Revision 1.41  2006/02/23 10:05:05  raasch
+! New unit 20 for data logging,
+! new units (111:113,116) for 2d/3d data averaging
+! NetCDF files are allowed a 64 bit offset format,
+! error number argument for handle_netcdf_error
+!
+! Revision 1.40  2005/06/30 10:39:04  raasch
+! No opening of units 101-108 in case of missing netcdf support
+!
+! Revision 1.39  2005/06/26 19:51:36  raasch
+! Data format version number for unit 85 changed
+!
+! Revision 1.38  2005/05/18 15:09:01  raasch
+! Extensions for NetCDF output
+!
+! Revision 1.37  2005/04/23 08:50:18  raasch
+! batch_scp calls is given the remote username as an additional argument
+!
+! Revision 1.36  2004/01/28 15:03:21  raasch
+! In case of opening unit 80, a barrier is set only for the first call of
+! check_open (from routine init_particles), in order to avoid the possibility
+! of hanging jobs, which may occur if unit 80 is opened within routine
+! allocate_prt_memory.
+!
+! Revision 1.35  2003/10/29 08:47:03  raasch
+! Call of batch_scp on IBM corrected, output of data format version and
+! particle group data on unit 85
+!
+! Revision 1.34  2003/05/09 14:06:58  raasch
+! Batch_scp paths for IBM, NEC and linux added
+!
+! Revision 1.33  2003/03/16 09:28:00  raasch
+! Two underscores (_) are placed in front of all define-strings
+!
+! Revision 1.32  2002/12/19 14:03:15  raasch
+! Unit 18 (CPU_MEASURES) will be opened on PE0 only, unit 14 is opened
+! with special process-id-string myid_char_14 (see routine parin),
+! STOP statement replaced by call of subroutine local_stop
+!
+! Revision 1.31  2002/04/24 19:01:15  raasch
+! Unit 85 is allowed to be re-opened. In case that a re-open of a file is not
+! allowed, the subroutine will be exit.
+!
+! Revision 1.30  2002/04/16 08:00:27  raasch
+! ftpcopy replaced by batch_scp, retry of opening CPU_MEASURES/ in case of
+! errors forced by adding ERR-parameter in OPEN statement.
+! New unit 85 for particle data
+!
+! Revision 1.29  2001/07/12 12:07:21  raasch
+! Opening of unit 33 moved out of ELSE-block
+!
+! Revision 1.28  2001/03/30 06:56:49  raasch
+! Translation of remaining German identifiers (variables, subroutines, etc.)
+!
+! Revision 1.27  2001/01/29 12:21:52  raasch
+! In case of AVS-output: if no path for ftpcopy is given, filenames are set
+! to "unknown"
+!
+! Revision 1.26  2001/01/25 06:54:28  raasch
+! Error concerning initialization of unit 23 removed (initial informations
+! were written also when reopened)
+!
+! Revision 1.25  2001/01/05 15:09:29  raasch
+! New units 81-84 for spectra
+!
+! Revision 1.24  2001/01/02 17:21:11  raasch
+! Re-opening of files is allowed, variable openfile now is of type file_status,
+! new unit 80 for particle informations
+! old revison remarks deleted
+!
+! Revision 1.23  2000/04/27 06:51:12  raasch
+! remote_addres changed to return_addres, old revision remarks deleted
+!
+! Revision 1.22  2000/01/21 17:07:18  letzel
+! All comments translated into English
 !
 ! Revision 1.1  1997/08/11 06:10:55  raasch
@@ -75,57 +100,51 @@
 ! Description:
 ! ------------
-!> Check if file unit is open. If not, open file and, if necessary, write a
-!> header or start other initializing actions, respectively.
-!--------------------------------------------------------------------------------------------------!
-SUBROUTINE check_open( file_id )
-
-
-    USE control_parameters,                                                                        &
-        ONLY:  coupling_char, data_output_2d_on_each_pe, max_masks, message_string, openfile,      &
-               run_description_header
-
-#if defined( __parallel )
-    USE control_parameters,                                                                        &
-        ONLY:  nz_do3d
-#endif
-
-    USE indices,                                                                                   &
-        ONLY:  nbgp, nx, nxl, nxr, ny, nyn, nys, nz, nzb, nzt
-
-    USE kinds
-
-#if defined( __netcdf )
-    USE NETCDF
-#endif
-
-    USE netcdf_interface,                                                                          &
-        ONLY:  id_set_agt, id_set_fl, id_set_mask, id_set_pr,                                      &
-               id_set_pts, id_set_sp, id_set_ts, id_set_xy, id_set_xz,                             &
-               id_set_yz, id_set_3d, nc_stat, netcdf_create_file,                                  &
-               netcdf_data_format, netcdf_define_header, netcdf_handle_error,                      &
-               netcdf_open_write_file
-
-    USE particle_attributes,                                                                       &
-        ONLY:  max_number_of_particle_groups, number_of_particle_groups, particle_groups
-
+! Check if file unit is open. If not, open file and, if necessary, write a
+! header or start other initializing actions, respectively.
+!------------------------------------------------------------------------------!
+
+    USE array_kind
+    USE arrays_3d
+    USE control_parameters
+    USE grid_variables
+    USE indices
+    USE netcdf_control
+    USE particle_attributes
     USE pegrid
-
-    USE posix_interface,                                                                           &
-        ONLY:  fortran_sleep
-
+    USE profil_parameter
+    USE statistics
 
     IMPLICIT NONE
 
-    CHARACTER (LEN=30)  ::  filename                !<
-    CHARACTER (LEN=4)   ::  mask_char               !<
-    CHARACTER (LEN=80)  ::  rtext                   !<
-
-    INTEGER(iwp) ::  av          !<
-    INTEGER(iwp) ::  file_id     !<
-    INTEGER(iwp) ::  ioerr       !< IOSTAT flag for IO-commands ( 0 = no error )
-    INTEGER(iwp) ::  mid         !< masked output running index
-
-    LOGICAL ::  file_exist       !< file check
-    LOGICAL ::  netcdf_extend    !<
+    CHARACTER (LEN=2)   ::  suffix
+    CHARACTER (LEN=20)  ::  return_addres, return_usern, xtext = 'time in s'
+    CHARACTER (LEN=30)  ::  filename
+    CHARACTER (LEN=40)  ::  avs_coor_file, avs_coor_file_localname, &
+                            avs_data_file_localname
+    CHARACTER (LEN=80)  ::  rtext
+    CHARACTER (LEN=100) ::  avs_coor_file_catalog, avs_data_file_catalog, &
+                            batch_scp, zeile
+    CHARACTER (LEN=400) ::  command
+
+    INTEGER ::  av, anzzeile = 1, cranz, file_id, i, iaddres, ierr1, iusern, &
+                j, k, legpos = 1, timodex = 1
+    INTEGER, DIMENSION(10) ::  cucol, klist, lstyle
+
+    LOGICAL ::  avs_coor_file_found = .FALSE., avs_data_file_found = .FALSE., &
+                datleg = .TRUE., get_filenames, grid = .TRUE., netcdf_extend, &
+                rand = .TRUE., swap = .TRUE., twoxa = .TRUE., twoya = .TRUE.
+
+    REAL ::  ansx = -999.999, ansy = -999.999, gwid = 0.1, rlegfak = 1.5, &
+             sizex = 250.0, sizey = 40.0, texfac = 1.5
+
+    REAL, DIMENSION(:), ALLOCATABLE      ::  eta, ho, hu
+    REAL(spk), DIMENSION(:), ALLOCATABLE ::  xkoor, ykoor, zkoor  
+
+
+    NAMELIST /RAHMEN/  anzzeile, cranz, datleg, rtext, swap
+    NAMELIST /CROSS/   ansx, ansy, cucol, grid, gwid, klist, legpos, lstyle, &
+                       rand, rlegfak, sizex, sizey, texfac, &
+                       timodex, twoxa, twoya, xtext
+                       
 
 !
@@ -135,20 +154,20 @@
 !
 !-- Only certain files are allowed to be re-opened
-!-- NOTE: some of the other files perhaps also could be re-opened, but it has not been checked so
-!-- far, if it works!
+!-- NOTE: some of the other files perhaps also could be re-opened, but it
+!--       has not been checked so far, if it works!
     IF ( openfile(file_id)%opened_before )  THEN
        SELECT CASE ( file_id )
-          CASE ( 13, 14, 21, 22, 23, 80, 85, 117 )
-             IF ( file_id == 14  .AND.  openfile(file_id)%opened_before )  THEN
-                message_string = 're-open of unit ' // '14 is not verified. Please check results!'
-                CALL message( 'check_open', 'PA0165', 0, 1, 0, 6, 0 )
-             ENDIF
-
+          CASE ( 14, 21, 22, 23, 80:85 )
+             IF ( file_id == 14 .AND. openfile(file_id)%opened_before )  THEN
+                IF ( myid == 0 )  PRINT*, '+++ check_open: re-open of unit ', &
+                                   ' 14 is not verified. Please check results!'
+             ENDIF
+             CONTINUE
           CASE DEFAULT
-             WRITE( message_string, * ) 're-opening of file-id ', file_id, ' is not allowed'
-             CALL message( 'check_open', 'PA0166', 0, 1, 0, 6, 0 )
-
+             IF ( myid == 0 )  THEN
+                PRINT*, '+++ check_open: re-opening of file-id ', file_id, &
+                        ' is not allowed'
+             ENDIF
              RETURN
-
        END SELECT
     ENDIF
@@ -158,38 +177,37 @@
     SELECT CASE ( file_id )
 
-       CASE ( 15, 16, 17, 18, 19, 50:59, 104:105, 107, 109, 117 )
+       CASE ( 15, 16, 17, 18, 19, 40:49, 50:59, 81:84, 101:107, 109, 111:113, &
+              116 )
 
           IF ( myid /= 0 )  THEN
-             WRITE( message_string, * ) 'opening file-id ', file_id, ' not allowed for PE ', myid
-             CALL message( 'check_open', 'PA0167', 2, 2, -1, 6, 1 )
-          ENDIF
-
-       CASE ( 101:103, 106, 111:113, 116, 201:200+2*max_masks )
-
-          IF ( netcdf_data_format < 5 )  THEN
-
+             PRINT*,'+++ check_open: opening file-id ',file_id, &
+                    ' not allowed for PE ',myid
+#if defined( __parallel )
+             CALL MPI_ABORT( comm2d, 9999, ierr )
+#else
+             CALL local_stop
+#endif
+          ENDIF
+
+       CASE ( 21, 22, 23 )
+
+          IF ( .NOT.  data_output_2d_on_each_pe )  THEN
              IF ( myid /= 0 )  THEN
-                WRITE( message_string, * ) 'opening file-id ', file_id, ' not allowed for PE ', myid
-                CALL message( 'check_open', 'PA0167', 2, 2, -1, 6, 1 )
-             ENDIF
-
-          ENDIF
-
-       CASE ( 21, 22, 23 )
-
-          IF ( .NOT. data_output_2d_on_each_pe )  THEN
-             IF ( myid /= 0 )  THEN
-                WRITE( message_string, * ) 'opening file-id ', file_id, ' not allowed for PE ', myid
-                CALL message( 'check_open', 'PA0167', 2, 2, -1, 6, 1 )
-             END IF
-          ENDIF
-
-       CASE ( 90:99 )
+                PRINT*,'+++ check_open: opening file-id ',file_id, &
+                       ' not allowed for PE ',myid
+#if defined( __parallel )
+                CALL MPI_ABORT( comm2d, 9999, ierr )
+#else
+                CALL local_stop
+#endif
+             ENDIF
+          ENDIF
+
+       CASE ( 27, 28, 29, 31, 32, 33, 71:73, 90:99 )
 
 !
 !--       File-ids that are used temporarily in other routines
-          WRITE( message_string, * ) 'opening file-id ', file_id,                                  &
-                                     ' is not allowed since it is used otherwise'
-          CALL message( 'check_open', 'PA0168', 0, 1, 0, 6, 0 )
+          PRINT*,'+++ check_open: opening file-id ',file_id, &
+                 ' is not allowed since it is used otherwise'
 
     END SELECT
@@ -200,48 +218,20 @@
 
        CASE ( 11 )
-!
-!--       Read the parameter file. Therefore, inquire whether the file exist or not. This is
-!--       required for the ocean-atmoshere coupling. For an ocean precursor run palmrun provides a
-!--       PARIN_O file instead of a PARIN file. Actually this should be considered in coupling_char,
-!--       however, in pmc_init the parameter file is already opened to read the nesting parameters
-!--       and decide whether it is a nested run or not, but coupling_char is still not set at that
-!--       moment (must be set after the nesting setup is read).
-!--       This, however, leads to the situation that for ocean precursor runs PARIN is not available
-!--       and the run crashes. Thus, if the file is not there, PARIN_O will be read. An ocean
-!--       precursor run will be the only situation where this can happen.
-          INQUIRE( FILE='PARIN' // TRIM( coupling_char ), EXIST=file_exist )
-
-          IF ( file_exist )  THEN
-             filename = 'PARIN' // TRIM( coupling_char )
-          ELSE
-             filename = 'PARIN_O'
-          ENDIF
-
-          OPEN ( 11, FILE=TRIM( filename ), FORM='FORMATTED', STATUS='OLD', IOSTAT=ioerr )
-
-          IF ( ioerr /= 0 )  THEN
-             message_string = 'namelist file "PARIN' // TRIM( coupling_char ) //                   &
-                              '"  or "PARIN_O" not found!' //                                      &
-                              '&Please have a look at the online description of the ' //           &
-                              'error message for further hints.'
-             CALL message( 'check_open', 'PA0661', 3, 2, 0, 6, 1 )
-          ENDIF
+
+          OPEN ( 11, FILE='PARIN', FORM='FORMATTED', STATUS='OLD' )
 
        CASE ( 13 )
 
           IF ( myid_char == '' )  THEN
-             OPEN ( 13, FILE='BININ' // TRIM( coupling_char ) // myid_char, FORM='UNFORMATTED',    &
+             OPEN ( 13, FILE='BININ'//myid_char, FORM='UNFORMATTED', &
                         STATUS='OLD' )
           ELSE
-!
-!--          First opening of unit 13 openes file _000000 on all PEs because only this file contains
-!--          the global variables.
-             IF ( .NOT. openfile(file_id)%opened_before )  THEN
-                OPEN ( 13, FILE='BININ' // TRIM( coupling_char ) // '/_000000', FORM='UNFORMATTED',&
-                           STATUS='OLD' )
-             ELSE
-                OPEN ( 13, FILE='BININ' // TRIM( coupling_char ) // '/' // myid_char,              &
-                           FORM='UNFORMATTED', STATUS='OLD' )
-             ENDIF
+#if defined( __t3eh ) || defined( __t3eb ) || defined( __t3ej5 )
+!
+!--          Declare a cache layer for faster I/O
+             CALL ASNUNIT ( 13, '-F cachea:512:1:1', ierr1 )
+#endif
+             OPEN ( 13, FILE='BININ/'//myid_char, FORM='UNFORMATTED', &
+                        STATUS='OLD' )
           ENDIF
 
@@ -249,85 +239,150 @@
 
           IF ( myid_char == '' )  THEN
-             OPEN ( 14, FILE='BINOUT' // TRIM( coupling_char ) // myid_char, FORM='UNFORMATTED',   &
+             OPEN ( 14, FILE='BINOUT'//myid_char, FORM='UNFORMATTED', &
                         POSITION='APPEND' )
           ELSE
              IF ( myid == 0  .AND. .NOT. openfile(file_id)%opened_before )  THEN
-                CALL local_system( 'mkdir  BINOUT' // TRIM( coupling_char ) )
+                CALL local_system( 'mkdir  BINOUT' )
              ENDIF
 #if defined( __parallel )
 !
-!--          Set a barrier in order to allow that all other processors in the directory created by
-!--          PE0 can open their file
+!--          Set a barrier in order to allow that all other processors in the 
+!--          directory created by PE0 can open their file
              CALL MPI_BARRIER( comm2d, ierr )
 #endif
-             ioerr = 1
-             DO WHILE ( ioerr /= 0 )
-                OPEN ( 14, FILE='BINOUT' // TRIM(coupling_char)// '/' // myid_char,                &
-                           FORM='UNFORMATTED', IOSTAT=ioerr )
-                IF ( ioerr /= 0 )  THEN
-                   WRITE( 9, * )  '*** could not open "BINOUT' //                                  &
-                                  TRIM(coupling_char) // '/' // myid_char //                       &
-                                  '"! Trying again in 1 sec.'
-                   CALL fortran_sleep( 1 )
-                ENDIF
+#if defined( __t3eh ) || defined( __t3eb ) || defined( __t3ej5 )
+!
+!--          Declare a cache layer for faster I/O
+             CALL ASNUNIT ( 14, '-F cachea:512:1:1', ierr1 )
+#endif
+             OPEN ( 14, FILE='BINOUT/'//myid_char_14, FORM='UNFORMATTED', &
+                        POSITION='APPEND' )
+          ENDIF
+
+       CASE ( 15 )
+
+          OPEN ( 15, FILE='RUN_CONTROL', FORM='FORMATTED' )
+
+       CASE ( 16 )
+
+          OPEN ( 16, FILE='LIST_PROFIL', FORM='FORMATTED' )
+
+       CASE ( 17 )
+
+          OPEN ( 17, FILE='LIST_PROFIL_1D', FORM='FORMATTED' )
+
+       CASE ( 18 )
+
+          OPEN ( 18, FILE='CPU_MEASURES', FORM='FORMATTED' )
+
+       CASE ( 19 )
+
+          OPEN ( 19, FILE='HEADER', FORM='FORMATTED' )
+
+       CASE ( 20 )
+
+          IF ( myid == 0  .AND. .NOT. openfile(file_id)%opened_before )  THEN
+             CALL local_system( 'mkdir  DATA_LOG' )
+          ENDIF
+          IF ( myid_char == '' )  THEN
+             OPEN ( 20, FILE='DATA_LOG/_0000', FORM='UNFORMATTED', &
+                        POSITION='APPEND' )
+          ELSE
+#if defined( __parallel )
+!
+!--          Set a barrier in order to allow that all other processors in the 
+!--          directory created by PE0 can open their file
+             CALL MPI_BARRIER( comm2d, ierr )
+#endif
+             OPEN ( 20, FILE='DATA_LOG/'//myid_char, FORM='UNFORMATTED', &
+                        POSITION='APPEND' )
+          ENDIF
+
+       CASE ( 21 )
+
+          IF ( data_output_2d_on_each_pe )  THEN
+             OPEN ( 21, FILE='PLOT2D_XY'//myid_char, FORM='UNFORMATTED', &
+                        POSITION='APPEND' )
+          ELSE
+             OPEN ( 21, FILE='PLOT2D_XY', FORM='UNFORMATTED', &
+                        POSITION='APPEND' )
+          ENDIF
+
+          IF ( myid == 0  .AND.  .NOT. openfile(file_id)%opened_before )  THEN
+!
+!--          Output for combine_plot_fields
+             IF ( data_output_2d_on_each_pe  .AND.  myid_char /= '' )  THEN
+                WRITE (21)  -1, nx+1, -1, ny+1    ! total array size
+                WRITE (21)   0, nx+1,  0, ny+1    ! output part
+             ENDIF
+!
+!--          Determine and write ISO2D coordiante header
+             ALLOCATE( eta(0:ny+1), ho(0:nx+1), hu(0:nx+1) )
+             hu = 0.0
+             ho = (ny+1) * dy
+             DO  i = 1, ny
+                eta(i) = REAL( i ) / ( ny + 1.0 )
              ENDDO
-
-          ENDIF
-
-       CASE ( 15 )
-
-          OPEN ( 15, FILE='RUN_CONTROL' // TRIM( coupling_char ), FORM='FORMATTED' )
-
-       CASE ( 16 )
-
-          OPEN ( 16, FILE='LIST_PROFIL' // TRIM( coupling_char ), FORM='FORMATTED' )
-
-       CASE ( 17 )
-
-          OPEN ( 17, FILE='LIST_PROFIL_1D' // TRIM( coupling_char ), FORM='FORMATTED' )
-
-       CASE ( 18 )
-
-          OPEN ( 18, FILE='CPU_MEASURES' // TRIM( coupling_char ), FORM='FORMATTED' )
-
-       CASE ( 19 )
-
-          OPEN ( 19, FILE='HEADER' // TRIM( coupling_char ), FORM='FORMATTED' )
-
-       CASE ( 20 )
-
-          IF ( myid == 0  .AND. .NOT. openfile(file_id)%opened_before )  THEN
-             CALL local_system( 'mkdir  DATA_LOG' // TRIM( coupling_char ) )
-          ENDIF
-          IF ( myid_char == '' )  THEN
-             OPEN ( 20, FILE='DATA_LOG' // TRIM( coupling_char ) // '/_000000', FORM='UNFORMATTED',&
-                        POSITION='APPEND' )
-          ELSE
-#if defined( __parallel )
-!
-!--          Set a barrier in order to allow that all other processors in the directory created by
-!--          PE0 can open their file
-             CALL MPI_BARRIER( comm2d, ierr )
-#endif
-             ioerr = 1
-             DO WHILE ( ioerr /= 0 )
-                OPEN ( 20, FILE='DATA_LOG' // TRIM( coupling_char ) // '/' // myid_char,           &
-                           FORM='UNFORMATTED', POSITION='APPEND', IOSTAT=ioerr )
-                IF ( ioerr /= 0 )  THEN
-                   WRITE( 9, * )  '*** could not open "DATA_LOG' // TRIM( coupling_char ) // '/' //&
-                                   myid_char // '"! Trying again in 1 sec.'
-                   CALL fortran_sleep( 1 )
-                ENDIF
+             eta(0)    = 0.0
+             eta(ny+1) = 1.0
+
+             WRITE (21)  dx,eta,hu,ho
+             DEALLOCATE( eta, ho, hu )
+
+!
+!--          Create output file for local parameters
+             IF ( iso2d_output )  THEN
+                OPEN ( 27, FILE='PLOT2D_XY_LOCAL', FORM='FORMATTED', &
+                           DELIM='APOSTROPHE' )
+                openfile(27)%opened = .TRUE.
+             ENDIF
+
+          ENDIF
+
+       CASE ( 22 )
+
+          IF ( data_output_2d_on_each_pe )  THEN
+             OPEN ( 22, FILE='PLOT2D_XZ'//myid_char, FORM='UNFORMATTED', &
+                        POSITION='APPEND' )
+          ELSE
+             OPEN ( 22, FILE='PLOT2D_XZ', FORM='UNFORMATTED', &
+                        POSITION='APPEND' )
+          ENDIF
+
+          IF ( myid == 0  .AND.  .NOT. openfile(file_id)%opened_before )  THEN
+!
+!--          Output for combine_plot_fields
+             IF ( data_output_2d_on_each_pe  .AND.  myid_char /= '' )  THEN
+                WRITE (22)  -1, nx+1, 0, nz+1    ! total array size
+                WRITE (22)   0, nx+1, 0, nz+1    ! output part
+             ENDIF
+!
+!--          Determine and write ISO2D coordiante header
+             ALLOCATE( eta(0:nz+1), ho(0:nx+1), hu(0:nx+1) )
+             hu = 0.0
+             ho = zu(nz+1)
+             DO  i = 1, nz
+                eta(i) = REAL( zu(i) ) / zu(nz+1)
              ENDDO
-
-          ENDIF
-
-       CASE ( 21 )
+             eta(0)    = 0.0
+             eta(nz+1) = 1.0
+
+             WRITE (22)  dx,eta,hu,ho
+             DEALLOCATE( eta, ho, hu )
+!
+!--          Create output file for local parameters
+             OPEN ( 28, FILE='PLOT2D_XZ_LOCAL', FORM='FORMATTED', &
+                        DELIM='APOSTROPHE' )
+             openfile(28)%opened = .TRUE.
+
+          ENDIF
+
+       CASE ( 23 )
 
           IF ( data_output_2d_on_each_pe )  THEN
-             OPEN ( 21, FILE='PLOT2D_XY' // TRIM( coupling_char ) // myid_char, FORM='UNFORMATTED',&
-                        POSITION='APPEND' )
-          ELSE
-             OPEN ( 21, FILE='PLOT2D_XY' // TRIM( coupling_char ), FORM='UNFORMATTED',             &
+             OPEN ( 23, FILE='PLOT2D_YZ'//myid_char, FORM='UNFORMATTED', &
+                        POSITION='APPEND' )
+          ELSE
+             OPEN ( 23, FILE='PLOT2D_YZ', FORM='UNFORMATTED', &
                         POSITION='APPEND' )
           ENDIF
@@ -335,111 +390,27 @@
           IF ( myid == 0  .AND.  .NOT. openfile(file_id)%opened_before )  THEN
 !
-!--          Write index bounds of total domain for combine_plot_fields
+!--          Output for combine_plot_fields
              IF ( data_output_2d_on_each_pe  .AND.  myid_char /= '' )  THEN
-                WRITE (21)   0, nx,  0, ny
-             ENDIF
-
-          ENDIF
-
-       CASE ( 22 )
-
-          IF ( data_output_2d_on_each_pe )  THEN
-             OPEN ( 22, FILE='PLOT2D_XZ' // TRIM( coupling_char ) // myid_char, FORM='UNFORMATTED',&
-                        POSITION='APPEND' )
-          ELSE
-             OPEN ( 22, FILE='PLOT2D_XZ' // TRIM( coupling_char ), FORM='UNFORMATTED',             &
-                        POSITION='APPEND' )
-          ENDIF
-
-          IF ( myid == 0  .AND.  .NOT. openfile(file_id)%opened_before )  THEN
-!
-!--          Write index bounds of total domain for combine_plot_fields
-             IF ( data_output_2d_on_each_pe  .AND.  myid_char /= '' )  THEN
-                WRITE (22)   0, nx, 0, nz+1    ! output part
-             ENDIF
-
-          ENDIF
-
-       CASE ( 23 )
-
-          IF ( data_output_2d_on_each_pe )  THEN
-             OPEN ( 23, FILE='PLOT2D_YZ' // TRIM( coupling_char ) // myid_char, FORM='UNFORMATTED',&
-                        POSITION='APPEND' )
-          ELSE
-             OPEN ( 23, FILE='PLOT2D_YZ' // TRIM( coupling_char ), FORM='UNFORMATTED',             &
-                        POSITION='APPEND' )
-          ENDIF
-
-          IF ( myid == 0  .AND.  .NOT. openfile(file_id)%opened_before )  THEN
-!
-!--          Write index bounds of total domain for combine_plot_fields
-             IF ( data_output_2d_on_each_pe  .AND.  myid_char /= '' )  THEN
-                WRITE (23)   0, ny, 0, nz+1    ! output part
-             ENDIF
-
-          ENDIF
-
-       CASE ( 25 )
-!
-!--       Binary files for surface data
-          ! OPEN ( 25, FILE='SURFACE_DATA_BIN' // TRIM( coupling_char ) // myid_char,               &
-          !            FORM='UNFORMATTED', POSITION='APPEND' )
-
-          IF ( myid_char == '' )  THEN
-             OPEN ( 25, FILE='SURFACE_DATA_BIN' // TRIM( coupling_char ) // myid_char,             &
-                        FORM='UNFORMATTED', POSITION='APPEND' )
-          ELSE
-             IF ( myid == 0  .AND. .NOT. openfile(file_id)%opened_before )  THEN
-                CALL local_system( 'mkdir  SURFACE_DATA_BIN' // TRIM( coupling_char ) )
-             ENDIF
-#if defined( __parallel )
-!
-!--          Set a barrier in order to allow that all other processors in the directory created by
-!--          PE0 can open their file
-             CALL MPI_BARRIER( comm2d, ierr )
-#endif
-             ioerr = 1
-             DO WHILE ( ioerr /= 0 )
-                OPEN ( 25, FILE='SURFACE_DATA_BIN' // TRIM(coupling_char) //  '/' // myid_char,    &
-                           FORM='UNFORMATTED', IOSTAT=ioerr )
-                IF ( ioerr /= 0 )  THEN
-                   WRITE( 9, * )  '*** could not open "SURFACE_DATA_BIN'// TRIM(coupling_char) //  &
-                                  '/' // myid_char // '"! Trying again in 1 sec.'
-                   CALL fortran_sleep( 1 )
-                ENDIF
+                WRITE (23)  -1, ny+1, 0, nz+1    ! total array size
+                WRITE (23)   0, ny+1, 0, nz+1    ! output part
+             ENDIF
+!
+!--          Determine and write ISO2D coordiante header
+             ALLOCATE( eta(0:nz+1), ho(0:ny+1), hu(0:ny+1) )
+             hu = 0.0
+             ho = zu(nz+1)
+             DO  i = 1, nz
+                eta(i) = REAL( zu(i) ) / zu(nz+1)
              ENDDO
-
-          ENDIF
-
-       CASE ( 26 )
-!
-!--       Binary files for averaged surface data
-          ! OPEN ( 26, FILE='SURFACE_DATA_AV_BIN' // TRIM( coupling_char ) // myid_char,            &
-          !        FORM='UNFORMATTED', POSITION='APPEND' )
-
-          IF ( myid_char == '' )  THEN
-             OPEN ( 26, FILE='SURFACE_DATA_AV_BIN' // TRIM( coupling_char ) // myid_char,          &
-                        FORM='UNFORMATTED', POSITION='APPEND' )
-          ELSE
-             IF ( myid == 0  .AND. .NOT. openfile(file_id)%opened_before )  THEN
-                CALL local_system( 'mkdir  SURFACE_DATA_AV_BIN' // TRIM( coupling_char ) )
-             ENDIF
-#if defined( __parallel )
-!
-!--          Set a barrier in order to allow that all other processors in the directory created by
-!--          PE0 can open their file
-             CALL MPI_BARRIER( comm2d, ierr )
-#endif
-             ioerr = 1
-             DO WHILE ( ioerr /= 0 )
-                OPEN ( 26, FILE='SURFACE_DATA_AV_BIN' // TRIM( coupling_char ) // '/' // myid_char,&
-                           FORM='UNFORMATTED', IOSTAT=ioerr )
-                IF ( ioerr /= 0 )  THEN
-                   WRITE( 9, * )  '*** could not open "SURFACE_DATA_AV_BIN' //                     &
-                                  TRIM( coupling_char ) // '/' // myid_char //                     &
-                                  '"! Trying again in 1 sec.'
-                   CALL fortran_sleep( 1 )
-                ENDIF
-             ENDDO
+             eta(0)    = 0.0
+             eta(nz+1) = 1.0
+
+             WRITE (23)  dx,eta,hu,ho
+             DEALLOCATE( eta, ho, hu )
+!
+!--          Create output file for local parameters
+             OPEN ( 29, FILE='PLOT2D_YZ_LOCAL', FORM='FORMATTED', &
+                        DELIM='APOSTROPHE' )
+             openfile(29)%opened = .TRUE.
 
           ENDIF
